import updateKeys from './lib/updateKeys';

/*export default function decryptChunk(encryptedChunk: Buffer, [key0, key1, key2]: [number, number, number]): {decryptedChunk: Buffer, keys: [number, number, number]} {
  const decryptedChunk = Buffer.alloc(encryptedChunk.length);
  const dvOut = new DataView(decryptedChunk.buffer);

  for (let i = 0; i < encryptedChunk.length; i += 1) {
    //read and decrypt byte
    let curChar = encryptedChunk.readUInt8(i);
    const keyPart = (key2 | 2) & 0xFFFF;
    const decryptedByte = (keyPart * (keyPart ^ 1)) >>> 8;
    curChar ^= decryptedByte & 0xFF;
    dvOut.setUint8(i, curChar);

    //update keys
    [key0, key1, key2] = updateKeys([key0, key1, key2], curChar);
  }

  return { decryptedChunk, keys: [key0, key1, key2] };
}*/

export default function getDecryptor([key0, key1, key2]: [number, number, number]) {
  let position = 0;

  return (encryptedChunk: Buffer) => {
    const decryptedChunk = Buffer.alloc(encryptedChunk.length);
    const dvOut = new DataView(decryptedChunk.buffer);

    for (let i = 0; i < encryptedChunk.length; i += 1) {
      //read byte
      let curChar = encryptedChunk.readUInt8(i);

      //decrypt byte
      const keyPart = (key2 | 2) & 0xFFFF;
      const decryptedByte = (keyPart * (keyPart ^ 1)) >>> 8;
      curChar ^= decryptedByte & 0xFF;

      //write byte
      if (position + i < 12) {
        //do nothing
      } else if (position + i >= 12 && position < 12) {
        dvOut.setUint8(position + i - 12, curChar);
      } else {
        dvOut.setUint8(i, curChar);
      }

      //update keys
      [key0, key1, key2] = updateKeys([key0, key1, key2], curChar);
    }

    position += encryptedChunk.length;

    return decryptedChunk;
  };
}
